clear all
close all
clc
%example-10;
L=20;T=25;A=1;
h=0.5;
N=L/h;
x=0:h:L;
delta_t=0.05;
N_t=T/delta_t;
t=0:delta_t:T;
[XX,TT]=meshgrid(x,t);
y=zeros(length(x),length(t));
y((10/h+1):(11/h+1),1)=1; %初值条件

rr=delta_t/h^2*A

for j=1:N_t    %时间上的步数
    for i=2:N   %空间上的点
        y(i,j+1)=rr*y(i+1,j)+(1-2*rr)*y(i,j)+rr*y(i-1,j);
    end
end
 
figure; plot(x,y(:,N_t+1)) %终了时刻杆上的温度分布
xlabel('x'),ylabel('u')
figure; surf(XX,TT,y')
xlabel('x'),ylabel('t'),zlabel('u')
figure; contourf(XX,TT,y')
xlabel('x'),ylabel('t')
colorbar